models/Contacto.php
<?php
namespace app\models;

use yii\base\Model;
use Yii;

Class Contacto extends Model{
    public $nombre;
    public $email;
    public $telefono;
    public $direccion;
    public $asunto;
    public $fecha;
    public $politicas;
    
    public function attributeLabels(){
        return [
            "nombre" => "Nombre completo",
            "email" => "Correo electronico",
            "telefono" => "Telefono",
            "direccion" => "Direccion completa",
            "asunto" => "¿Cual es tu pregunta?",
            "fecha" => "Fecha Nacimiento",
            "politicas" => "Aceptar politica de privacidad"
        ];
    }
    
    public function rules(){
        return[
            [["nombre","email","telefono"],"required"],
            ["email","email"],
            ["nombre","string","length"=>[1,100]],
            ["politicas",'boolean'],
            //["fecha","date","format"=>'dd/mm/yyyy'],
            ["fecha","string"],
            [["direccion","asunto"],"safe"],
            ["politicas","comprobarpoliticas"], // chequear si has aceptado las politicas
        ];
    }
    
    /**
     *  chequear que hayas aceptado las politicas
     * 
     */
    public function comprobarpoliticas($attribute,$params){
        if($this->$attribute==0){
            $this->addError($attribute,"Es necesario que aceptes las politicas de privacidad");
        }
        
    }
    
    public function contact(){
        if ($this->validate()) {
            Yii::$app->mailer->compose()
                ->setTo(Yii::$app->params['contacto'])
                ->setFrom([Yii::$app->params['senderEmail'] => Yii::$app->params['senderName']])
                ->setReplyTo([$this->email => $this->nombre])
                ->setSubject("contacto")
                ->setTextBody($this->asunto)
                ->send();

            return true;
        }
        return false;
    }

}

models/Productos.php
<?php
namespace app\models;
use Yii;

/**
 * This is the model class for table "productos".
 *
 * @property int $id
 * @property string|null $nombre
 * @property string|null $foto
 * @property string|null $descripcion
 * @property float|null $precio
 * @property int|null $oferta
 * @property string|null $categorias
 */
class Productos extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'productos';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id'], 'required'],
            [['id', 'oferta'], 'integer'],
            [['precio'], 'number'],
            [['nombre', 'foto', 'categorias'], 'string', 'max' => 100],
            [['descripcion'], 'string', 'max' => 2000],
            [['id'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'nombre' => 'Nombre',
            'foto' => 'Foto',
            'descripcion' => 'Descripcion',
            'precio' => 'Precio',
            'oferta' => 'Oferta',
            'categorias' => 'Categorias',
        ];
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use app\models\Productos;
use yii\data\ActiveDataProvider;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionDonde()
    {
        return $this->render('donde');
    }
    
    public function actionQuienes()
    {
        return $this->render('quienes');
    }
    
    public function actionNuestros()
    {
        return $this->render('nuestros');
    }
    
    public function actionInformacion()
    {
        return $this->render('informacion');
    }
    

    public function actionOfertas()
    {

        $consulta=Productos::find()->where([
            "oferta" => 1
        ]);

        
        $dataProvider=new ActiveDataProvider([
            'query' => $consulta
        ]);
        
        return $this->render("ofertas",[
            "dataProvider" => $dataProvider,
        ]);
    }
    
    public function actionProductos()
    {
        
        $consulta=Productos::find();
        
        $dataProvider=new ActiveDataProvider([
            'query' => $consulta,
            'pagination' => [
                'pageSize' => 1,
            ],
        ]);
        
        return $this->render("productos",[
            "dataProvider" => $dataProvider,
        ]);
  
    }
    
    public function actionCategorias()
    {
        $consulta=Productos::find()->select("categorias")->distinct();
        
        $dataProvider=new ActiveDataProvider([
            'query' => $consulta,
        ]);
        
        return $this->render("categorias",[
            "dataProvider" => $dataProvider,
        ]);
    }
    
      
    public function actionContacto()
    {
    $model = new \app\models\Contacto(); // objeto de tipo contacto
        
    $datos=Yii::$app->request->post(); // leoo todos los datos enviados y los coloco en $datos
    
    if ($model->load($datos)) {
        if ($model->contact()) {
            /** chequear si has aceptado las politicas desde el controlador */
            /*if($model->politicas==0){
                $model->addError("politicas","No has aceptado las politicas");
            }else{
                return $this->render("mostrar");
            }*/
            
                return $this->render("mostrar");
                
        }
    }

    return $this->render('contacto', [
        'model' => $model,
    ]);
    }
    
    public function actionProductoscategoria($categoria){
        
        $consulta=Productos::find()->where([
            "categorias"=>$categoria
        ]);
        
                
        $dataProvider=new ActiveDataProvider([
            'query' => $consulta,
        ]);
        
        return $this->render("productoscategoria",[
            "dataProvider" => $dataProvider,
            "categoria" =>$categoria
        ]);        
        
    }
    
    
}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header>
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav d-flex'],
        'encodeLabels'=>false,
        'items' => [
            ['label' => '<i class="fas fa-house-user"></i> Inicio', 'url' => ['/site/index']],
            ['label' => '<i class="fa fa-check" aria-hidden="true"></i> Ofertas', 'url' => ['/site/ofertas']],
            ['label' => '<i class="fa fa-cube" aria-hidden="true"></i> Productos', 'url' => ['/site/productos']],
            ['label' => '<i class="fas fa-layer-group"></i> Categorias', 'url' => ['/site/categorias']],
            ['label'=>'Nosotros', 'items'=>[
                ['label' => 'Donde estamos', 'url' => ['/site/donde']],
                ['label' => 'Quienes somos', 'url' => ['/site/quienes']],
                ['label' => 'Nuestros productos', 'url' => ['/site/nuestros']],
                '<div class="dropdown-divider"></div>',
                ['label' => 'Informacion', 'url' => ['/site/informacion']],
            ]],
            ['label' => 'Contacto', 'url' => ['/site/contacto']],
        ],
    ]);
    NavBar::end();
    ?>
</header>

<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer class="footer mt-auto py-3 text-muted">
    <div class="container">
        <p class="float-left">&copy; My Company <?= date('Y') ?></p>
        <p class="float-right"><?= Yii::powered() ?></p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/_categorias.php
<?php

use yii\helpers\Html;

echo Html::a($model->categorias,
        ['site/productoscategoria','categoria'=>$model->categorias],
        ['class'=>'col-lg-12 d-block p-4 mb-5 btn btn-primary text-uppercase']
        );

views/site/_ofertas.php
<?php
use yii\helpers\Html;
?>
<div class="row">
    <div class="col-lg-5">
    <?php
    echo Html::img("@web/imgs/$model->foto",[
    "class" =>"img-fluid"
    ]);
    
    ?>
    </div>
    <div class="col-lg-7">
        <h2><?= $model->nombre ?><br></h2>
        <div class="bg-warning rounded p-2">Precio:</div>
        <div class="p-1"><?= $model->precio ?> €</div>
        <div class="bg-warning rounded p-2">Descripcion:</div>
        <div class="p-1"><?= $model->descripcion ?></div>
        <div class="bg-warning rounded p-2">Categoria:</div>
        <div class="p-1"><?= $model->categorias ?></div>
    </div>
    
</div>

views/site/_productoscategoria.php
<?php
use yii\helpers\Html;
?>
<div class="row">
    <div class="col-lg-5">
    <?php
    echo Html::img("@web/imgs/$model->foto",[
    "class" =>"card-img-top"
    ]);
    
    ?>
    </div>
    <div class="col-lg-7">
        <h2><?= $model->nombre ?><br></h2>
        <div class="bg-warning rounded p-2">Precio:</div>
        <div class="p-1"><?= $model->precio ?> €</div>
        <div class="bg-warning rounded p-2">Descripcion:</div>
        <div class="p-1"><?= $model->descripcion ?></div>
    </div>
    
</div>

views/site/categorias.php
<?php
use yii\widgets\ListView;
?>

<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">
    Categorias
</h1>
    
<?php
echo ListView::widget([
    "dataProvider" => $dataProvider,
    "itemView" => "_categorias",
    "itemOptions" => [
        'class' => 'col-lg-4',
    ],
    "options" => [
        'class' => 'row',
    ],
    'layout'=>"{items}"
]);

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/* @var $this yii\web\View */

$this->title = 'Jota';
?>
<div class="site-index">
    <div class="body-content">

        <div class="row">
            <div class="col-lg-8 mx-auto">
                <h2 class="p-2 mx-auto my-4 border border-primary rounded text-center">Productos de Jota</h2>

                <div class="text-justify">
                    Lorem ipsum dolor sit amet, consectetur adipisicing elit. Ipsum, quam, esse ab labore provident laborum nemo ea. 
                    Impedit, est beatae rerum adipisci harum nam eum labore vitae fugit dolores ipsam.
                    Lorem ipsum dolor sit amet, consectetur adipisicing elit. Rerum, eum, temporibus similique alias harum qui quia 
                    quo quaerat fuga optio commodi blanditiis repudiandae sequi reiciendis illo voluptas voluptate impedit possimus.
                </div>

            </div>
        </div>

    </div>
</div>

views/site/informacion.php
<?php

views/site/login.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap4\ActiveForm */
/* @var $model app\models\LoginForm */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n<div class=\"col-lg-3\">{input}</div>\n<div class=\"col-lg-8\">{error}</div>",
            'labelOptions' => ['class' => 'col-lg-1 col-form-label'],
        ],
    ]); ?>

        <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput() ?>

        <?= $form->field($model, 'rememberMe')->checkbox([
            'template' => "<div class=\"offset-lg-1 col-lg-3 custom-control custom-checkbox\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
        ]) ?>

        <div class="form-group">
            <div class="offset-lg-1 col-lg-11">
                <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            </div>
        </div>

    <?php ActiveForm::end(); ?>

    <div class="offset-lg-1" style="color:#999;">
        You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
        To modify the username/password, please check out the code <code>app\models\User::$users</code>.
    </div>
</div>

views/site/mostrar.php
Muchas gracias en breve nos pondremos en contacto.

views/site/nuestros.php
<?php
use yii\bootstrap4\Carousel;

echo Carousel::widget([
    'items' => [
        // the item contains only the image
        '<img src="https://picsum.photos/800/600?random=1"/>',
        // equivalent to the above
        ['content' => '<img src="https://picsum.photos/800/600?random=2"/>'],
        // the item contains both the image and the caption
        [
            'content' => '<img src="https://picsum.photos/800/600?random=3"/>',
            'caption' => '<h4>This is title</h4><p>This is the caption text</p>',
        ],
    ],
    'options'=>[
        'class'=>'mx-auto col-lg-8'
    ],
    'controls' => ['<i class="fas fa-arrow-left fa-3x"></i>','<i class="fas fa-arrow-right fa-3x"></i>']
]);

views/site/ofertas.php
<?php
    use yii\widgets\ListView;
?>
<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">
    Productos en Oferta
</h1>
<?php
echo ListView::widget([
    "dataProvider" => $dataProvider,
    "itemView" => "_ofertas",
    "itemOptions" => [
        'class' => 'col-lg-5 ml-auto mr-auto bg-light p-3 mb-5',
    ],
    "options" => [
        'class' => 'row',
    ],
    'layout'=>"{items}"
]);

views/site/productos.php
<?php

use yii\grid\GridView;
use yii\helpers\Html;
?>

<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">
    Listado de productos
</h1>

<?= GridView::widget([
    "dataProvider" => $dataProvider,
    "layout"=>"{summary}<br>{pager}<br>{items}<br>{pager}<br>{summary}",
    "pager"=>[
        "options" => ["class"=>"row col-6"],
        "linkOptions"=>["class"=>"p-2 d-block w-100 h-100"],
        "disabledPageCssClass"=>"p-2 rounded d-block col-1 border",
        "activePageCssClass"=>"bg-light",
        "nextPageCssClass"=>"rounded d-block col-1 border",
        "prevPageCssClass"=>"rounded d-block col-1 border",
        "pageCssClass"=>"rounded d-block col-1 p-0 border",
    ],
    "columns"=>[
        'id',
        'nombre',
        'precio',
        'categorias',
        [
            'attribute'=>'foto',
            'label'=>'Foto Producto',
            'format'=>'raw',
            'value' => function($data){
                $url = "@web/imgs/$data->foto";
                return Html::img($url,['style'=>'width:200px','class'=>'img-fluid mx-auto d-block']); 
            } 
        ],
        'descripcion',
        'oferta'
    ],
    "options"=>[
        "class" => "text-center"
    ]
]) ?>

views/site/productoscategoria.php
<?php
use yii\widgets\ListView;
?>
<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">
    Listado de Productos de Categoria <?= $categoria ?></h1>
<?php
echo ListView::widget([
    "dataProvider" => $dataProvider,
    "itemView" => "_productoscategoria",
    "itemOptions" => [
        'class' => 'col-lg-5 ml-auto mr-auto bg-light p-3 mb-5',
    ],
    "options" => [
        'class' => 'row',
    ],
    'layout'=>"{items}"
]);

views/site/quienes.php
<?php